--[[
			%%%%%%				%%%%%%%%%%			%%%%%%%%%%%%
		%%%%%%%%%%%%%   	%%%%%%%%%%%%%%%%%%%		   %%%%%%	
	   %%%        %%%%    %%%%%            %%%%%        %%%%
	  %%%%		   %%%    %%%%			    %%%%        %%%%
      %%%%%				  %%%%               %%%		%%%%
	   %%%%%%   		  %%%%							%%%%
		  %%%%%%          %%%%							%%%%
              %%%%%       %%%%         %%%%%%			%%%%
			     %%%%     %%%%%         %%%%%%% 		%%%%
			     %%%%%     %%%%%           %%%%			%%%%
			    %%%%%       %%%%%		  %%%%			%%%%
	 %%%%     %%%%%           %%%%%%%%%%%%%%%          %%%%%%
	  %%%%%%%%%%			   %%%%%%%%%%%%%        %%%%%%%%%%%%

	  SuperGuildInvite 
	  
											Written by
											
			Janniie - Stormreaver EU


]]
--*****************************************************************--
--**                     File Global Variables                   **--
--*****************************************************************--

--%% AddOn Version %%--
local VERSION_MAJOR = "5.1"
local VERSION_MINOR = ""

--%% AddOn Slash commands %%--
SLASH_SUPERGUILDINVITE1 = '/sgi'
SLASH_SUPERGUILDINVITE2 = '/superguildinvite'

--%% AddonMessage ID's %%--
local ID_VERSION = "SGI_VERSION"
local ID_REQUEST = "SGI_REQUEST"
local ID_BLACK = "SGI_BLACK"

--%% The SGI logo %%--
local LOGO = "|cffffff00<|r|cff16ABB5SGI|r|cffffff00>|r "

--%% SGI UI Tables %%--
local SGI_UI = {
	Frames = {
		Checkbox = {}, 
		Button = {}, 
		Window = {}, 
		Droptown = {}, 
		Tooltips = {}, 
		Highlights = {}, 
		InviteFrames = {} 
	},
	Functions = {},
	FontStrings = {}, 
}

--%% Dropdown menues selects %%--
local dropdownSelect = {}

--%% Keeping track of the players location %%--
local inBattleground
local inDungeon
local dungeonFinnished



--%%%%%%%%%%%%%%%%%%%%%%%%%%--
--%% Related to SuperScan %%--
--%%%%%%%%%%%%%%%%%%%%%%%%%%--

--&& Timing &&--
local whoTime = 0
local cooldown
local whoDelay = 7
local timeLeft = 0
local timerTime = 0
local progressBar = 0

--&& Who searching && --
local scanZone = 1
local superScanning
local whoQueryList = {}
local sessionTotal = 0
local amountScanned = 0
local amountGuildless = 0
local amountQueued = 0
local whoSent
local limitChanged
local SuperScanFrame = CreateFrame("Frame")
local SGI_Queue = {}

--&& Used to restore force-closed frames &&--
local activeFrames = {}

--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%--
--%% Localized Functions for regular use %%--
--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%--

local GetTime = GetTime
local strfind = strfind
local strsub = strsub
local tonumber = tonumber


--:::::::::::::::::::::::::::::::::::::::::::::::::::::::::--
		
		

--- ***************************************** ---
--- *** Frequently used utility functions *** ---
--- ***************************************** ---
		
	-- && Returns the number of elements in a table && --
	-- && Does not require the table to have a 		&& --
	-- && numeric index								&& --
	
local function CountTable(T)
	local i = 0
	if type(T) ~= "table" then
		return i
	end
	for k,_ in pairs(T) do
		i = i + 1
	end
	return i
end

	-- && Format seconds to:    && --
	-- && X hours Y mins Z secs && --
	
local function FormatTime(T)
	local R,S,M,H = ""
	T = floor(T)
	H = floor(T/3600)
	M = floor((T-3600*H)/60)
	S = T-(3600*H + 60*M)
		
	if T <= 0 then
		return "less than 1 second"
	end
		
	if H ~= 0 then
		R =  R..H.." hours "
	end
	if M ~= 0 then
		R = R..M.." minutes "
	end
	if S ~= 0 then
		R = R..S.." seconds"
	end
	
	return R
end

	-- && Return classColors && --
	
local function GetClassColor(classFileName)
	if classFileName == "DEATHKNIGHT" then
		return "C41F3B" 
	elseif classFileName == "DRUID" then
		return "FF7D0A"
	elseif classFileName == "HUNTER" then
		return "ABD473"
	elseif classFileName == "MAGE" then
		return "69CCF0"
	elseif classFileName == "PALADIN" then
		return "F58CBA"
	elseif classFileName == "PRIEST" then
		return "FFFFFF"
	elseif classFileName == "ROGUE" then
		return "FFF569"
	elseif classFileName == "SHAMAN" then
		return "0070DE"
	elseif classFileName == "WARLOCK" then
		return "9482C9"
	elseif classFileName == "WARRIOR" then
		return "C79C6E"
	else
		return "857C7C"
	end
end
		
	-- && Removes a object in a table from its key && --
	-- && instead of index.						   && --
local function SpecialTableRemove(Table,Key)
	local OUT = {}
	for k,_ in pairs(Table) do
		if k ~= Key then
			OUT[k] = Table[k]
		end
	end
	return OUT
end


	-- && Two function to Save and Position frames && --
	
local function PlaceFrame(Frame)
	if not Frame then return end
	local name = Frame:GetName()
	if type(SuperGuildInviteOptions["FRAMES"][name]) ~= "table" then
		SuperGuildInviteOptions["FRAMES"][name] = {}
	end
	SuperGuildInviteOptions["FRAMES"][name]["X"] = SuperGuildInviteOptions["FRAMES"][name]["X"] or 0
	SuperGuildInviteOptions["FRAMES"][name]["Y"] = SuperGuildInviteOptions["FRAMES"][name]["Y"] or 0
	SuperGuildInviteOptions["FRAMES"][name]["P1"] = SuperGuildInviteOptions["FRAMES"][name]["P1"] or "CENTER"
	SuperGuildInviteOptions["FRAMES"][name]["P2"] = SuperGuildInviteOptions["FRAMES"][name]["P2"] or "CENTER"
	
	Frame:SetPoint(
		SuperGuildInviteOptions["FRAMES"][name]["P1"],
		UIParent,
		SuperGuildInviteOptions["FRAMES"][name]["P2"],
		SuperGuildInviteOptions["FRAMES"][name]["X"],
		SuperGuildInviteOptions["FRAMES"][name]["Y"]
	)
end

local function RememberPosition(Frame)
	if not Frame then return end
	local name = Frame:GetName()
	local point,relativeTo,relativePoint,xOfs,yOfs = Frame:GetPoint()
	if type(SuperGuildInviteOptions["FRAMES"][name]) ~= "table" then
		SuperGuildInviteOptions["FRAMES"][name] = {}
	end
	SuperGuildInviteOptions["FRAMES"][name]["X"] = xOfs
	SuperGuildInviteOptions["FRAMES"][name]["Y"] = yOfs
	SuperGuildInviteOptions["FRAMES"][name]["P1"] = point
	SuperGuildInviteOptions["FRAMES"][name]["P2"] = relativePoint
end

	-- && This function checks which frames are open && --

local function GetActiveFrames()
	activeFrames = {}
	if WorldMapFrame and WorldMapFrame:IsShown() then
		activeFrames["WorldMapFrame"] = WorldMapFrame
	end
	if CharacterFrame and CharacterFrame:IsShown() then
		activeFrames["Character"] = CharacterFrame
	end
	if SpellBookFrame and SpellBookFrame:IsShown() then
		activeFrames["SpellBook"] = SpellBookFrame
	end
	if EncounterJournal and EncounterJournal:IsShown() then
		activeFrames["Encounter"] = EncounterJournal
	end
	if PlayerTalentFrame and PlayerTalentFrame:IsShown() then
		activeFrames["Talent"] = PlayerTalentFrame
	end
	if AchievementFrame and AchievementFrame:IsShown() then
		activeFrames["Achievement"] = AchievementFrame
	end
end

	-- && This function restores force-closed frames --
	
local function RestoreActiveWindows()
	for k,_ in pairs(activeFrames) do
		activeFrames[k]:Show()
	end
	activeFrames = {}
end
		
		
-- ::::::::::::::::::::::::::::::::::::::::::::::::::: --
-- ::: Functions related to the SuperScan feature  ::: --
-- ::::::::::::::::::::::::::::::::::::::::::::::::::: --

	-- && Queues a player for an invite && --
	
local function QueueInvite(name,level,classFile,race,class,inviteTime,inviteDay)
	SGI_Queue[name] = {
		level = level,
		class = class,
		classFile = classFile,
		race = race,
		inviteTime = inviteTime,
	}
	amountQueued = amountQueued + 1
	GuildShield:IsShielded(name)
end


	-- && Add or Remove a player from the Blacklist && --
	
local function AddToBlacklist(name,mode,share)
	BlackList[name] = mode
	if not share then
		SendAddonMessage(ID_BLACK,name,"GUILD")
	end
	if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
		print(LOGO.."|cffff0000"..name.."|r"..SGI_ADDED_TO_BLACKLIST)
	end
end

local function RemoveFromBlacklist(name)
	BlackList[name] = nil
	if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
		print(LOGO.."|cffff0000"..name.."|r"..SGI_REMOVED_FROM_BLACKLIST)
	end
end

	-- && Display the Blacklist && --

local function DisplayBlacklist()
	print(LOGO.."|cff88aaffCurrently Blacklisted players:|r")
	for k,_ in pairs(BlackList) do
		if BlackList[k] == "AUTOMATIC" then
			print(LOGO.."|cff33ff33"..k.."|r|cff88aaff was added automatically.|r")
		elseif BlackList[k] == "GUILDSHARE" then
			print(LOGO.."|cff33ff33"..k.."|r|cff88aaff was added by guild sharing.|r")
		else
			print(LOGO.."|cff33ff33"..k.."|r|cff88aaff was added manually.|r")
		end
	end
end
		
	-- && Format the custom whisper message && --
	
local function FormatWhisper(msg,name)
	local whisper = msg
	if not name then name = "ExampleName" end
	local guildName,guildLevel = GetGuildInfo(UnitName("Player")),GetGuildLevel()
	if strfind(msg,"PLAYER") then
		whisper = strsub(msg,1,strfind(msg,"PLAYER")-1)..name..strsub(msg,strfind(msg,"PLAYER")+6)
	end
	if strfind(whisper,"NAME") then
		whisper = strsub(whisper,1,strfind(whisper,"NAME")-1)..guildName..strsub(whisper,strfind(whisper,"NAME")+4)
	end
	if strfind(whisper,"LEVEL") then
		whisper = strsub(whisper,1,strfind(whisper,"LEVEL")-1)..guildLevel..strsub(whisper,strfind(whisper,"LEVEL")+5)
	end
	return whisper
end

	-- && Invite a player to the guild && --
	
local function InvitePlayer(name)
	if SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] and (SuperGuildInviteOptions["Dropdown"]["SGI_WHISPERWAIT"] or 0) == 2 then 
		local Whisper = FormatWhisper(SuperGuildInviteOptions.Whisper,name)
		SendChatMessage(Whisper,"WHISPER",nil,name)
		GuildInvite(name)
	elseif not SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] then
		GuildInvite(name)
	elseif SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] and (SuperGuildInviteOptions["Dropdown"]["SGI_WHISPERWAIT"] or 0) == 3 then
		local Whisper = FormatWhisper(SuperGuildInviteOptions.Whisper,name)
		SendChatMessage(Whisper,"WHISPER",nil,name)
	else
		GuildInvite(name)
	end
	SGI_Queue = SpecialTableRemove(SGI_Queue,name)
	
	if SGI_INVITEBUTTONFont then
		SGI_INVITEBUTTONFont:SetText("Invite: "..CountTable(SGI_Queue))
	end
	if SGI_InviteButtonFont then
		SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_Queue))
	end
	SuperGuildInviteGeneral["DATES"][name] = tonumber(date("%j"))
	SuperGuildInviteGeneral["TRIES"]["tries "..name] = (SuperGuildInviteGeneral["TRIES"]["tries "..name] or 0) + 1
end

local function InvitePlayerButton()
	if CountTable(SGI_Queue) == 0 then
		print(LOGO.."|cff88aaffThe queue is empty!|r")
	else
		for k,_ in pairs(SGI_Queue) do
			SuperGuildInviteGeneral["DATES"][k] = tonumber(date("%j"))
			SuperGuildInviteGeneral["TRIES"]["tries "..k] = (SuperGuildInviteGeneral["TRIES"]["tries "..k] or 0) + 1
			if SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] and (SuperGuildInviteOptions["Dropdown"]["SGI_WHISPERWAIT"] or 0) == 2 then 
				local Whisper = FormatWhisper(SuperGuildInviteOptions.Whisper,k)
				SendChatMessage(Whisper,"WHISPER",nil,k)
				GuildInvite(k)
			elseif not SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] then
				GuildInvite(k)
			elseif SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] and (SuperGuildInviteOptions["Dropdown"]["SGI_WHISPERWAIT"] or 0) == 3 then
				local Whisper = FormatWhisper(SuperGuildInviteOptions.Whisper,k)
				SendChatMessage(Whisper,"WHISPER",nil,k)
			else
				GuildInvite(k)
			end
			SGI_Queue = SpecialTableRemove(SGI_Queue,k)
	
			if SGI_INVITEBUTTONFont then
				SGI_INVITEBUTTONFont:SetText("Invite: "..CountTable(SGI_Queue))
			end
			if SGI_InviteButtonFont then
				SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_Queue))
			end
			break
		end
	end
end

	-- && Remove a player from the queue && --

local function RemoveQueued(name)
	SGI_Queue = SpecialTableRemove(SGI_Queue,name)
	SuperGuildInviteGeneral["DATES"][name] = tonumber(date("%j"))
end





	-- && Update the frame with the queued players listed && --

local function ListNamesToInvite()
	if not (SGI_INVITELISTFRAME and SGI_INVITELISTFRAME:IsShown()) then return end
	local X,Y,i = 10, -30, 0
	local tooltipTime = 0
	
	for k,_ in pairs(SGI_UI.Frames.InviteFrames) do
		SGI_UI.Frames.InviteFrames[k]:Hide()
	end
	
	local Names = {}
	SGI_INVITELISTFRAME:SetHeight(20*CountTable(SGI_Queue) + 40)
	
	for k,_ in pairs(SGI_Queue) do
		i = i + 1
		local level,classFile,race,class,inviteTime = SGI_Queue[k].level, SGI_Queue[k].classFile, SGI_Queue[k].race, SGI_Queue[k].class, SGI_Queue[k].inviteTime
		local Text = i..". |cff"..GetClassColor(classFile)..k.."|r Lvl "..level.." "..race.." |cff"..GetClassColor(classFile)..class.."|r"
		Names[i] = k
		SGI_UI.Frames.InviteFrames[i] = CreateFrame("Button","SuperGuildInviteFrame"..i)
		SGI_UI.Frames.InviteFrames[i]:SetWidth(290)
		SGI_UI.Frames.InviteFrames[i]:SetHeight(20)
		SGI_UI.Frames.InviteFrames[i]:SetPoint("TOPLEFT",SGI_INVITELISTFRAME,"TOPLEFT",X,Y)
		Y = Y - 20
		SGI_UI.Frames.InviteFrames[i]:Show()
		SGI_UI.Frames.InviteFrames[i]:SetFrameStrata("HIGH")
		SGI_UI.Frames.InviteFrames[i]:RegisterForClicks("LeftButtonDown","RightButtonDown")
		SGI_UI.Frames.InviteFrames[i]:SetScript("OnClick",function(self,button)
			if button == "LeftButton" then
				InvitePlayer(k)
				ListNamesToInvite()
			else
				RemoveQueued(k)
				ListNamesToInvite()
			end
		end)
		
		local Font = SGI_UI.Frames.InviteFrames[i]:CreateFontString("SuperGuildInviteFrameFont"..i,"OVERLAY","GameFontNormal")
		Font:SetText(Text)
		Font:SetPoint("LEFT",SGI_UI.Frames.InviteFrames[i],"LEFT",3,0)
		Font:SetJustifyH("LEFT")
		
	end
	for j = 1,i do
		SGI_UI.Frames.Highlights[j] = SGI_UI.Frames.InviteFrames[j]:CreateTexture()
		SGI_UI.Frames.Highlights[j]:SetPoint("CENTER",SGI_UI.Frames.InviteFrames[j],"CENTER",-5,0)
		SGI_UI.Frames.Highlights[j]:SetWidth(280)
		SGI_UI.Frames.Highlights[j]:SetHeight(17)
		SGI_UI.Frames.Highlights[j]:SetTexture(1,1,0,0.2)
		SGI_UI.Frames.Highlights[j]:Hide()
			
		SGI_UI.Frames.Tooltips[j] = CreateFrame("Frame","ToolTip_SGI"..j,SGI_UI.Frames.InviteFrames[j],"GameTooltipTemplate")
		SGI_UI.Frames.Tooltips[j]:SetPoint("RIGHT",SGI_UI.Frames.InviteFrames[j],"LEFT",-5,0)
		SGI_UI.Frames.Tooltips[j]:SetWidth(200)
		SGI_UI.Frames.Tooltips[j]:SetHeight(50)
		
		local font = SGI_UI.Frames.Tooltips[j]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		font:SetPoint("LEFT",SGI_UI.Frames.Tooltips[j],"LEFT",10,0)
		font:SetText("Queued: "..FormatTime(GetTime() - SGI_Queue[Names[j]].inviteTime).." ago")
		font:SetWidth(190)
		font:SetJustifyH("LEFT")
					
		SGI_UI.Frames.InviteFrames[j]:SetScript("OnEnter",function()
			SGI_UI.Frames.Highlights[j]:Show()
			SGI_UI.Frames.Tooltips[j]:Show()
			SGI_UI.Frames.Tooltips[j]:SetScript("OnUpdate",function()
				if GetTime() - tooltipTime > 1 then
					font:SetText("Queued: "..FormatTime(GetTime() - SGI_Queue[Names[j]].inviteTime).." ago")
					tooltipTime = GetTime()
				end
			end)
		end)
		SGI_UI.Frames.InviteFrames[j]:SetScript("OnLeave",function()
			SGI_UI.Frames.Highlights[j]:Hide()
			SGI_UI.Frames.Tooltips[j]:Hide()
		end)
		SGI_UI.Frames.Tooltips[j]:SetScript("OnUpdate",function()
			if GetTime() - tooltipTime > 1 then
				font:SetText("Queued: "..FormatTime(GetTime() - SGI_Queue[Names[j]].inviteTime).." ago")
				tooltipTime = GetTime()
			end
			SGI_UI.Frames.Tooltips[j]:SetScript("OnUpdate",nil)
		end)
	end
end

	-- && SuperScan:
	-- && Systematicly scan the entire server
	-- && for guildless players

local function SuperScan()
	if SuperGuildInviteOptions["Checkbox"]["SGI_ENABLE_BOX"] and superScanning and GetTime() - whoTime > whoDelay then
		if scanZone == #whoQueryList + 1 then
			scanZone = 1
			sessionTotal = sessionTotal + amountScanned
			if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
				print(LOGO..SGI_SCAN_COMPLETE)
				print(LOGO..SGI_PLAYERS_SCANNED.."|cff44FF44"..amountScanned.." |r|cffffff00(Total: "..sessionTotal..")|r")
				print(LOGO..SGI_GUILDLESS_PLAYERS.."|cff44FF44"..amountGuildless.."|r|cffffff00 "..(floor(1000*amountGuildless/amountScanned)/10).."%|r")
				print(LOGO..SGI_INVITES_QUEUED.."|cff44FF44"..amountQueued.."|r")
			end
			amountScanned = 0
			amountGuildless = 0
			amountQueued = 0
			whoTime = GetTime() + 8
			timeLeft = 15
			cooldown = true
			return
		else
			timeLeft = (#whoQueryList - scanZone + 1) * whoDelay
			SetWhoToUI(1)
			GetActiveFrames()
			SendWho(whoQueryList[scanZone])
			whoSent = true
			cooldown = false
		end
		whoTime = GetTime()
	end	
end
SuperScanFrame:SetScript("OnUpdate",SuperScan)


	-- && Creates the querys used by SuperScan

--[[local function CreateSuperScanQuery(low,high)
	local Levels,i = {}
	high = high or 85
	if not low then 
		tinsert(Levels,"-4")
		i = 5
	elseif mod(low,5) ~= 0 then
		tinsert(Levels,low.."- -"..low+(5-mod(low,5)))
		i = low + (5-mod(low,5))
	else
		i = low
	end
	while i < high and i < 80 do
		tinsert(Levels,i.."- -"..i+4)
		i = i + 5
	end
	i = low
	while i < high and i < 85 and i >= low do
		tinsert(Levels,i.."- -"..i+1)
		i = i + 2
		if i == 84 then
			tinsert(Levels,"84")
			break
		end
	end

	if high == 85 then
		local Classes = {
			"Death Knight",
			"Priest",
			"Druid",
			"Mage",
			"Warrior",
			"Warlock",
			"Paladin",
			"Rogue",
			"Shaman",
			"Hunter",
		}
		for k,_ in pairs(Classes) do
			tinsert(Levels,"85 c-"..Classes[k])
		end
	end
	scanZone = 1
	whoQueryList = Levels
	for k,_ in pairs(whoQueryList) do
		print(whoQueryList[k])
	end
end]]

local function CreateSuperScanQuery(low,high)
	local Levels,i = {}
	high = high or 85
	
	if not low then 
		tinsert(Levels,"-9")
		i = 10
	elseif mod(low,10) ~= 0 and low < 80 then
		tinsert(Levels,low.."- -"..low+(10-mod(low,10)))
		i = low + (10-mod(low,10))
	else
		i = low
	end
	

	
	while i < high and i < 80 do
		tinsert(Levels,i.."- -"..i+9)
		i = i + 10
		if i > high and mod(high,10) ~= 0 then
			tinsert(Levels,(i-10).."- -"..high)
		end
	end
	if high >= 80 then
		local k = 80
		while k < high do
			if k >= low then
				tinsert(Levels,tostring(k))
			end
			k = k + 1
		end
	end
	if high == 85 then
		local Classes = {
			"Death Knight",
			"Druid",
			"Hunter",
			"Mage",
			"Paladin",
			"Priest",
			"Rogue",
			"Shaman",
			"Warlock",
			"Warrior",
		}
		for k,_ in pairs(Classes) do
			tinsert(Levels,"85 c-"..Classes[k])
		end
	end
			
	
	scanZone = 1
	whoQueryList = Levels
end

local function ClearOutdatedEntries()
	local extraTime,count,msg = 0,0
	if not SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] or SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 1 then
		extraTime = 0
	elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 2 then
		extraTime = 1
	elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 3 then
		extraTime = 3
	elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 4 then
		extraTime = 6
	elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 5 then
		extraTime = 13
	end
	for k,_ in pairs(SuperGuildInviteGeneral["DATES"]) do
		if SuperGuildInviteGeneral["DATES"][k] < tonumber(date("%j")) - extraTime then
			SuperGuildInviteGeneral["DATES"][k] = nil
			count = count + 1
		end
	end
	if tonumber(date("%j")) < SuperGuildInviteGeneral[UnitName("player")] then
		SuperGuildInviteGeneral["DATES"] = {}
		count = "All lockouts due to newyear"
	end
	return count
end



--- :::::::::::::::::::::::::::::::::::::::::::::: ---
--- ::: 	 Functions used for filtering	   ::: ---
--- :::::::::::::::::::::::::::::::::::::::::::::: ---

local function CreateFilter()
	local n = SGI_FILTERNAME:GetText()
	local c,i = {},0
	local H,L = 85,1
	local ID = 1
	local Filter = {}
	local Classes = {
			"Death Knight",
			"Druid",
			"Hunter",
			"Paladin",
			"Mage",
			"Priest",
			"Rogue",
			"Shaman",
			"Warlock",
			"Warrior",
		}
	if not n or n == "" then
		n = "Filter"..CountTable(SuperGuildInviteGeneral.filter) + 1
	end
	
	if SuperGuildInviteOptions["Checkbox"]["SGI_USECLASS"] then
		for k,_ in pairs(Classes) do
			i = i + 1
			if SuperGuildInviteOptions["Checkbox"]["SGI_FILTERCLASS"..i] then
				c[Classes[k]] = true
			end
		end
	end
	
	if SuperGuildInviteOptions["Checkbox"]["SGI_FILTERLEVEL"] then
		H,L = SuperGuildInviteOptions.HighFilterLimit,SuperGuildInviteOptions.LowFilterLimit
	end
	
	ID = SuperGuildInviteOptions["Dropdown"]["FILTERMODE"] or ID
	
	for k,_ in pairs(Classes) do
		if c[Classes[k]] then
			Filter[Classes[k]] = {
				invite = ID,
				lvlH = H,
				lvlL = L,
			}
		end
	end
	
	
	SuperGuildInviteGeneral.filter[n] = Filter
	SGI_FilterCreate:Hide()
	SGI_FilterOpt:Hide()
	SGI_FilterOpt = nil
end

--[[
Filter model:

	Filter = {
		["ClassName"] = {
			invite = "Invite on match = 1",
			lvlH = "Highest allowed levle",
			lvlL = "Lowest",
		}
	}
	
]]

local function GetActiveFilters()
	local Active = {}
	for k,_ in pairs(SuperGuildInviteGeneral.filter) do
		if SuperGuildInviteOptions["Checkbox"]["SGI_FILTER"..k] then
			Active[k] = SuperGuildInviteGeneral.filter[k]
		end
	end
	return Active
end

local function MatchFilter(Filter,Class,level)
	if Filter[Class] and Filter[Class].invite == 1 then
		if Filter[Class].lvlH >= level and Filter[Class].lvlL <= level then
			return true
		end
	elseif Filter[Class] and Filter[Class].invite == 2 then
		if not (Filter[Class].lvlH >= level and Filter[Class].lvlL <= level) then
			return true
		end
	end
	
	return false
	
end

local function FilterAndQueue(Name,level,classFile,race,class,inviteTime,inviteDay)
	local F = GetActiveFilters()
	for k,_ in pairs(F) do
		if MatchFilter(F[k],class,level) then
			QueueInvite(Name,level,classFile,race,class,inviteTime,inviteDay)
		end
	end
end


local function DisplayFilter(name)
	if not SuperGuildInviteGeneral.filter[name] then
		print("Invalid filtername...")
	else
		local C,c = ""
		local S
		for k,_ in pairs(SuperGuildInviteGeneral.filter[name]) do
			C = C..", "..k
			c = k
		end
		C = strsub(C,3)
		if SuperGuildInviteGeneral.filter[name][c].invite == 1 then
			S = "Invite if matching"
		else
			S = "Don't invite if matching"
		end
		if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
			print(LOGO.."|cff88aaffFilter name: |r|cffffff00"..name.."|r")
			print(LOGO.."|cff88aaffClass(es): |r|cffffff00"..C.."|r")
			print(LOGO.."|cff88aaffLevel range: |r|cffffff00"..SuperGuildInviteGeneral.filter[name][c].lvlL.." - "..SuperGuildInviteGeneral.filter[name][c].lvlH.."|r")
			print(LOGO.."|cff88aaffStatus: "..S.."|r")
		end
	end
end

--- :::::::::::::::::::::::::::::::::::::::::::::: ---
--- ::: Functions that are triggered by events ::: ---
--- :::::::::::::::::::::::::::::::::::::::::::::: ---

	-- && When a who query becomes available
	
local function WhoQueryAvailable()
	if SuperGuildInviteOptions["Checkbox"]["SGI_ENABLE_BOX"] and whoSent then
		whoSent = false
		if superScanning then
			scanZone = scanZone + 1
		end
		for i = 1 , GetNumWhoResults() do
			amountScanned = amountScanned + 1
			local name, guild, level, race, class, zone, classFileName = GetWhoInfo(i)
			if guild == "" then
				amountGuildless = amountGuildless + 1
				local inviteDay = tonumber(date("%j"))
				local extraTime
				if not SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] or SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 1 then
					extraTime = 0
				elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 2 then
					extraTime = 1
				elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 3 then
					extraTime = 3
				elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 4 then
					extraTime = 6
				elseif SuperGuildInviteOptions["Dropdown"]["SGI_REINVITE"] == 5 then
					extraTime = 13
				end
				if not SuperGuildInviteGeneral["DATES"][name] or inviteDay > (extraTime + SuperGuildInviteGeneral["DATES"][name]) then
					if not BlackList[name] then
						if SuperGuildInviteOptions["Checkbox"]["SGI_AUTOBLACKLIST"] and (SuperGuildInviteGeneral["TRIES"]["tries "..name] or 0) >= (SuperGuildInviteOptions.tries or 3) then
							AddToBlacklist(name,"AUTOMATIC")
						else
							if SuperGuildInviteOptions["Checkbox"]["SGI_ADVANCEDFILTERING"] then
								FilterAndQueue(name,level,classFileName,race,class,GetTime(),inviteDay)
							else
								QueueInvite(name,level,classFileName,race,class,GetTime(),inviteDay)
								if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
									ChatFrame1:AddMessage(LOGO..name..SGI_PLAYER_NOT_IN_GUILD,1,0.2,0.2,1)
								end
							end
						end
					else
						if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
							print(LOGO.."|cffff0000"..name.."|r"..SGI_IS_BLACKLISTED)
						end
					end
				end
			end
		end
		ListNamesToInvite()
		if SuperGuildInviteOptions["Checkbox"]["SGI_AUTOCLOSE"] then
			FriendsFrameCloseButton:Click()
			RestoreActiveWindows()
		end
		if SGI_INVITEBUTTONFont then
			SGI_INVITEBUTTONFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
		if SGI_InviteButtonFont then
			SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
	end		
end

	-- && The player logs in
	
local function LoginPlayer()
	if type(SuperGuildInviteGeneral) ~= "table" or tonumber(date("%j")) < (SuperGuildInviteGeneral[UnitName("Player")] or 0) then --New user or new year
		SuperGuildInviteGeneral = {}
		SuperGuildInviteGeneral["DATES"] = {}
		SuperGuildInviteGeneral["TRIES"] = {}
		SuperGuildInviteGeneral[UnitName("Player")] = tonumber(date("%j"))
	end
	if not SuperGuildInviteGeneral[UnitName("player")] then
		SuperGuildInviteGeneral[UnitName("Player")] = tonumber(date("%j"))
	end
	if type(SuperGuildInviteGeneral["DATES"]) ~= "table" then
		SuperGuildInviteGeneral["DATES"] = {}
	end
	if type(SuperGuildInviteGeneral["TRIES"]) ~= "table" then
		SuperGuildInviteGeneral["TRIES"] = {}
	end
	if type(SuperGuildInviteOptions) ~= "table" then
		SuperGuildInviteOptions = {}
		SuperGuildInviteOptions["FRAMES"] = {}
		SuperGuildInviteOptions.tries = 3
		SuperGuildInviteOptions.Whisper = "Would you like to join my guild? The please press Accept!"
	end
	if type(SuperGuildInviteOptions["FRAMES"]) ~= "table" then
		SuperGuildInviteOptions["FRAMES"] = {}
	end
	if type(SuperGuildInviteOptions["Checkbox"]) ~= "table" then
		SuperGuildInviteOptions["Checkbox"] = {}
	end
	if type(SuperGuildInviteOptions["Dropdown"]) ~= "table" then
		SuperGuildInviteOptions["Dropdown"] = {}
	end
	if type(BlackList) ~= "table" then
		BlackList = {}
	end
	if type(SuperGuildInviteGeneral.filter) ~= "table" then
		SuperGuildInviteGeneral.filter = {}
		SuperGuildInviteGeneral.filter["Test1"] = {}
		SuperGuildInviteGeneral.filter["Test2"] = {}
		SuperGuildInviteGeneral.filter["Test3"] = {}
	end
	
	RegisterAddonMessagePrefix(ID_REQUEST)
	RegisterAddonMessagePrefix(ID_VERSION)
	RegisterAddonMessagePrefix(ID_BLACK)
	
	SendAddonMessage(ID_REQUEST,"","GUILD")
	SendAddonMessage(ID_VERSION,VERSION_MAJOR,"GUILD")
	
	GuildShield:Initiate(RemoveQueued)
	
	SuperGuildInviteOptions.LowLimit = SuperGuildInviteOptions.LowLimit or 1
	SuperGuildInviteOptions.HighLimit = SuperGuildInviteOptions.HighLimit or 85
	
	CreateSuperScanQuery(SuperGuildInviteOptions.LowLimit,SuperGuildInviteOptions.HighLimit)
	
	PlaceFrame(SGI_MiniMapButton)
	if not SuperGuildInviteOptions["Checkbox"]["SGI_SILENTMODE"] then
		print(LOGO.."|cff88aaffCleared |r|cffffff00"..ClearOutdatedEntries().."|r|cff88aaff outdated lockouts|r")
	end
	print(LOGO..SGI_HELP)
end

	-- && Addon Message recieved

local function AddonMessage(prefix,msg,sender)
	if sender ~= UnitName("player") then
		if prefix == ID_VERSION then
			if tonumber(msg) > tonumber(VERSION_MAJOR) then
				print(LOGO.."|cff88aaffThere's a new version (|r|cffffff00"..msg.."|r|cff88aaff) of SGI available.|r")
			end
		elseif prefix == ID_BLACK then
			AddToBlacklist(msg,"GUILDSHARE",true)
		elseif prefix == ID_REQUEST then
			for k,_ in pairs(BlackList) do
				SendAddonMessage(ID_BLACK,k,"GUILD")
			end
		end
	end
	--print("|cff88aaffPrefix: |r|cffffff00"..prefix.."|r")
	--print("|cff88aaffMessage: |r|cffffff00"..msg.."|r")
	--print("|cff88aaffSender: |r|cffffff00"..sender.."|r")
	--print(" ")
end

	
	-- && A system message was recieved
	
local function OnSystemMessage(msg,sender)
	if strfind(msg," is declining all") and SuperGuildInviteOptions["Checkbox"]["SGI_AUTOBLACKLIST"] then
		local name = strsub(msg,1,strfind(msg," is declining")-1)
		AddToBlacklist(name,"AUTOMATIC")
	elseif SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] and (SuperGuildInviteOptions["Dropdown"]["SGI_WHISPERWAIT"] or 1) == 1 and strfind(msg," to join your guild.") then
		local name = strsub(msg,strfind(msg," invited ")+9,strfind(msg," to join your guild.")-1)
		local Whisper = FormatWhisper(SuperGuildInviteOptions.Whisper,name)
		SendChatMessage(Whisper,"WHISPER",nil,name)
	end
end


	-- && This function will detect the current event
	-- && and call the appropriate function
	
local function OnRegisteredEvent(self,event,...)
	if event == "WHO_LIST_UPDATE" then
		WhoQueryAvailable()
	elseif event == "CHAT_MSG_SYSTEM" then
		local msg,sender = select(1,...)
		OnSystemMessage(msg,sender)
	elseif event == "CHAT_MSG_ADDON" then
		local prefix,msg,channel,sender = select(1,...)
		AddonMessage(prefix,msg,sender)
	elseif event == "PLAYER_LOGIN" then
		LoginPlayer()
	end
end

local SGI_EVENTFRAME = CreateFrame("Frame","SGI_EVENTFRAME")
SGI_EVENTFRAME:RegisterEvent("PLAYER_LOGIN")
SGI_EVENTFRAME:RegisterEvent("WHO_LIST_UPDATE")
SGI_EVENTFRAME:RegisterEvent("CHAT_MSG_SYSTEM")
SGI_EVENTFRAME:RegisterEvent("CHAT_MSG_ADDON")
SGI_EVENTFRAME:SetScript("OnEvent",OnRegisteredEvent)



--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::: ---
--- :::      All the frames used by SuperGuildInvite     ::: ---
--- :::			With related functions:					 ::: ---
--- :::			* Buttons,Checkboxes					 ::: ---
--- :::			* Dropdown menu							 ::: ---
--- :::			* Timer Frame							 ::: ---
--- :::			* Invitelist Frame						 ::: ---
--- :::			* Custom Whisper Frame					 ::: ---
--- :::			* Filter Frames						 	 ::: ---
--- :::			* Help frame							 ::: ---
--- :::			* Main Options Frame					 ::: ---
--- ::: 		* MiniMap Icon							 ::: ---
--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::: ---


local function CreateNewButton(name,parent,width,height,label,anchor,OnClick)
	local f = CreateFrame("Button",name,parent,"UIPanelButtonTemplate")
	f:SetWidth(width)
	f:SetHeight(height)
	local Label = f:CreateFontString(name.."Font","OVERLAY","GameFontNormalSmall")
	Label:SetText(label)
	Label:SetPoint("CENTER")
	
	if type(anchor) == "table" then
		f:SetPoint(anchor.point,parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	end
	f:SetScript("OnClick",OnClick)
	return f
end

local function CreateNewCheckbox(name,parent,label,anchor)
	local f = CreateFrame("CheckButton",name,parent,"OptionsBaseCheckButtonTemplate")
	local l = f:CreateFontString(name.."Font","OVERLAY","GameFontNormal")
	l:SetText(label)
	l:SetPoint("LEFT",f,"RIGHT",5,1)
	if type(anchor) == "table" then
		f:SetPoint(anchor.point,parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	end
	f:HookScript("OnClick",function(self)
		SuperGuildInviteOptions["Checkbox"][name] = self:GetChecked()
	end)
	if SuperGuildInviteOptions["Checkbox"][name] then
		f:SetChecked()
	end
	return f
end

local function CreateDropDown(Parent,NAME,anchor,ITEMS,name,label)
	local Drop = CreateFrame("Button", NAME, Parent, "UIDropDownMenuTemplate")

	Drop:ClearAllPoints()
	Drop:SetPoint(anchor.point,Parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	Drop:Show()
	
	local Label = Drop:CreateFontString(nil,"OVERLAY","GameFontNormal")
	Label:SetPoint("BOTTOMLEFT",Drop,"TOPLEFT",20,5)
	Label:SetText(label or "")

	local items = {
	"All",
	"Deathknight",
	"Druid",
	"Hunter",
	"Paladin",
	"Mage",
	"Priest",
	"Rogue",
	"Shaman",
	"Warlock",
	"Warrior",
	}
	items = ITEMS or items
	name = name or "Class"
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(Drop, self:GetID())
		SuperGuildInviteOptions["Dropdown"][name] = self:GetID()
	end
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end

	UIDropDownMenu_Initialize(Drop, initialize)
	UIDropDownMenu_SetWidth(Drop, 100);
	UIDropDownMenu_SetButtonWidth(Drop, 124)
	UIDropDownMenu_SetSelectedID(Drop, SuperGuildInviteOptions["Dropdown"][name] or 1)
	UIDropDownMenu_JustifyText(Drop, "LEFT")
end

local function CreateInviteListFrame()
	local f = CreateFrame("Frame","SGI_INVITELISTFRAME")
	f:SetWidth(300)
	f:SetHeight(20*CountTable(SGI_Queue) + 40)
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	f:SetBackdrop(backdrop)
	
	local fo = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	fo:SetPoint("TOP",f,"TOP",-15,-15)
	fo:SetText("Click on the players you wish to invite")
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	f:SetScript("OnShow",ListNamesToInvite)
	f:SetScript("OnHide",function()
		for k,_ in pairs(SGI_UI.Frames.InviteFrames) do
			SGI_UI.Frames.InviteFrames[k]:Hide()
		end
	end)
	ListNamesToInvite()
end

local function CreateTimerFrame()
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	local T = CreateFrame("Frame","SGI_TimerFrame")
	T:SetHeight(75) --??
	T:SetWidth(270)
	PlaceFrame(T)
	T:SetMovable()
	T:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	T:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	T:SetBackdrop(backdrop)
	
	local TF = T:CreateFontString("SGI_TimerFont","OVERLAY","GameFontNormal")
	TF:SetPoint("CENTER",0,15)
	TF:SetText("HH:MM:SS")
	
	local anchor = {
		point = "BOTTOMLEFT",
		relativePoint = "BOTTOMLEFT",
		xOfs = 7,
		yOfs = 10,
	}
	
	local p = CreateFrame("Button","SGI_ProgressFrame",T)
	p:SetWidth(270)
	p:SetHeight(30)
	p:SetBackdrop(backdrop)
	p:SetPoint("TOP",T,"BOTTOM",0,-1)
	local pf = p:CreateFontString("SGI_ProgPercent","OVERLAY","GameFontNormalLarge")
	pf:SetPoint("CENTER")
	pf:SetText("")
	pf:SetTextColor(0,1,0)
	local pt = p:CreateTexture("SGI_ProgTexture")
	pt:SetPoint("LEFT",5,0)
	pt:SetHeight(19)
	pt:SetWidth(1)
	pt:SetTexture(1,0.5,0,0.4)
	local pTool = CreateFrame("Frame","ProgTool",p,"GameTooltipTemplate")
	pTool:SetWidth(120)
	pTool:SetHeight(40)
	pTool:SetPoint("TOP",p,"BOTTOM")
	local pToolF = pTool:CreateFontString(nil,"OVERLAY","GameFontNormal")
	pToolF:SetPoint("LEFT",pTool,"LEFT",10,0)
	pToolF:SetJustifyH("LEFT")
	pToolF:SetText("Click to stop SuperScan")
	pToolF:SetWidth(110)
	p:SetScript("OnEnter",function()
		pTool:Show()
	end)
	p:SetScript("OnLeave",function()
		pTool:Hide()
	end)
	p:SetScript("OnClick",function()
		if superScanning then
			SuperScanFrame:SetScript("OnUpdate",nil)
			superScanning = false
			if SGI_TimerFrame then SGI_TimerFrame:Hide() end
			SGI_MainOptionsFrame:Show()
		end
	end)
	
	
	local b1 = CreateNewButton("SGI_PurgeQueue",T,85,25,"Purge Queue",anchor,function()
		SGI_Queue = {}
		if SGI_INVITEBUTTONFont then
			SGI_INVITEBUTTONFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
		if SGI_InviteButtonFont then
			SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
		ListNamesToInvite()
	end)
	anchor.xOfs = 92
	local b2 = CreateNewButton("SGI_InviteButton",T,85,25,"Invite: "..CountTable(SGI_Queue),anchor,function()
		InvitePlayerButton()
		ListNamesToInvite()
	end)
	anchor.xOfs = 177
	local b3 = CreateNewButton("SGI_ChooseInviteButton",T,85,25,"Choose Invites",anchor,function()
		if SGI_INVITELISTFRAME and SGI_INVITELISTFRAME:IsShown() then
			SGI_INVITELISTFRAME:Hide()
		elseif SGI_INVITELISTFRAME then
			SGI_INVITELISTFRAME:Show()
		else
			CreateInviteListFrame()
		end
	end)
end

local function ToggleTimer(F)
	if F then
		if not SGI_TimerFrame then
			CreateTimerFrame()
		else
			SGI_TimerFrame:Show()
		end
	else
		if SGI_TimerFrame and SGI_TimerFrame:IsShown() then
			SGI_TimerFrame:Hide()
		elseif SGI_TimerFrame then
			SGI_TimerFrame:Show()
		else
			CreateTimerFrame()
		end
	end
end

local function UpdateTimerFrame()
	if GetTime() - timerTime >= 1 then
		local Time
		if timeLeft <= 0 then
			Time = SGI_TIMER_DEFAULT.."00:00:00"
		else
			local sec = timeLeft
			local hour = floor(sec/3600)
			local mins = floor((sec-3600*hour)/60)
			local secs = sec-3600*hour-60*mins
			if hour < 10 then hour = "0"..hour end
			if mins < 10 then mins = "0"..mins end
			if secs < 10 then secs = "0"..secs end
			local text
			if cooldown then
				text = SGI_TIMER_DEFAULT
				if timeLeft <= 1 then
					cooldown = false
				end
			else
				text = SGI_TIMER_REMAINING
			end
			Time = text..hour..":"..mins..":"..secs
		end
		SGI_TimerFont:SetText(Time)
		timeLeft = timeLeft - 1
		timerTime = GetTime()
	elseif GetTime() - progressBar >= 0.5 then
		if SGI_ProgTexture and cooldown and sessionTotal ~= 0 then
			SGI_ProgTexture:SetWidth(260)
			SGI_ProgPercent:SetText("100%")
		elseif SGI_ProgTexture and cooldown then
			SGI_ProgTexture:SetWidth(1)
			SGI_ProgPercent:SetText("0%")
		elseif SGI_ProgTexture then
			local CurrentTime = (#whoQueryList+1) * whoDelay - timeLeft
			local TotalTime = (#whoQueryList+1) * whoDelay
			SGI_ProgTexture:SetWidth(floor(260*(CurrentTime/TotalTime)))
			SGI_ProgPercent:SetText(floor(100*(CurrentTime/TotalTime)).."%")
		end
		progressBar = GetTime()
	end	
end

local function CreateCustomWhisperFrame()
	local f = CreateFrame("Frame","SGI_CUSTOM_FILTER_FRAME")
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	f:SetWidth(500)
	f:SetHeight(365)
	f:SetBackdrop(backdrop)
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local TitleFont = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("SuperGuildInvite Custom Whisper")
	TitleFont:SetPoint("TOP",f,"TOP",0,-20)
	
	local ExplainFont = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	ExplainFont:SetPoint("TOPLEFT",f,"TOPLEFT",35,-55)
	ExplainFont:SetText("Create a customized whisper to send people you invite! If you enter the words (must be caps) |cff00ff00NAME|r, |cff0000ffLEVEL|r or |cffff0000PLAYER|r these will be replaced by your |cff00ff00Guildname|r, |cff0000ffGuildlevel|r and |cffff0000the recieving players name|r.")
	ExplainFont:SetWidth(450)
	ExplainFont:SetJustifyH("LEFT")
	
	local frame1 = CreateFrame("EditBox","SGI_WHISPERBOX",f)
	frame1:SetWidth(450)
	frame1:SetHeight(65)
	frame1:SetMultiLine(true)
	frame1:SetPoint("TOPLEFT",f,"TOPLEFT",35,-140)
	frame1:SetFontObject("GameFontNormal")
	frame1:SetTextInsets(10, 10, 10, 10)
	frame1:SetMaxLetters(256)
	frame1:SetMovable()
	frame1:SetText(SuperGuildInviteOptions.Whisper)
	frame1:SetBackdrop(backdrop)
	frame1:SetScript("OnHide",function()
		frame1:SetText(SuperGuildInviteOptions.Whisper)
	end)
	local font1 = frame1:CreateFontString(nil,"OVERLAY","GameFontNormal")
	font1:SetPoint("TOPLEFT",frame1,"TOPLEFT",10,13)
	font1:SetText("Enter your whisper")
	anchor = {}
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 100
		anchor.yOfs = 20
	
	CreateNewButton("SGI_SAVEWHISPER",f,120,30,"Save",anchor,function()
		local W = frame1:GetText()
		SuperGuildInviteOptions.Whisper = W
		SendChatMessage(FormatWhisper(W,UnitName("Player")),"WHISPER",nil,UnitName("player"))
		f:Hide()
	end)
	anchor.xOfs = 280
	CreateNewButton("SGI_CANCELWHISPER",f,120,30,"Cancel",anchor,function()
		f:Hide()
	end)
	
end

local function ToggleWhisperFrame()
	if SGI_CUSTOM_FILTER_FRAME and SGI_CUSTOM_FILTER_FRAME:IsShown() then
		SGI_CUSTOM_FILTER_FRAME:Hide()
	elseif SGI_CUSTOM_FILTER_FRAME then
		SGI_CUSTOM_FILTER_FRAME:Show()
	else
		CreateCustomWhisperFrame()
	end
end

local function CreateAdvancedFilterCreationFrame()
	local f = CreateFrame("Frame","SGI_FilterCreate")
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	f:SetWidth(500)
	f:SetHeight(365)
	f:SetBackdrop(backdrop)
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local TitleFont = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("SuperGuildInvite Filter Creation")
	TitleFont:SetPoint("TOP",f,"TOP",0,-20)
	
	local frame1 = CreateFrame("EditBox","SGI_FILTERNAME",f)
	frame1:SetWidth(120)
	frame1:SetHeight(30)
	frame1:SetPoint("TOPLEFT",f,"TOPLEFT",35,-70)
	frame1:SetFontObject("GameFontNormal")
	frame1:SetTextInsets(10, 10, 5, 5)
	frame1:SetMaxLetters(256)
	frame1:SetMovable()
	frame1:SetBackdrop(backdrop)
	frame1:SetScript("OnHide",function()
		frame1:SetText("")
	end)
	local font1 = frame1:CreateFontString(nil,"OVERLAY","GameFontNormal")
	font1:SetPoint("TOP",frame1,"TOP",0,13)
	font1:SetText("Filter Name")
	
	local anchor = {}
		anchor.point = "TOPLEFT"
		anchor.relativeFrame = f
		anchor.relativePoint = "TOPLEFT"
		anchor.xOfs = 20
		anchor.yOfs = -140
	
	
	CreateDropDown(f,"SGI_FILTERMODE",anchor,{"Invite if matching","Don't invite if matching"},"FILTERMODE","Filter Mode")
		anchor.xOfs = 30
		anchor.yOfs = -180
	local B2 = CreateNewCheckbox("SGI_FILTERLEVEL",f,"Use level filter",anchor)
	
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 100
		anchor.yOfs = 20
	
	CreateNewButton("SGI_SAVEFILTER",f,120,30,"Save",anchor,CreateFilter)
	anchor.xOfs = 280
	CreateNewButton("SGI_CANCELFILTER",f,120,30,"Cancel",anchor,function()
		f:Hide()
	end)
	
	
		anchor.point = "CENTER"
		anchor.relativePoint = "CENTER"
		anchor.xOfs = 40
		anchor.yOfs = 100
	local B1 = CreateNewCheckbox("SGI_USECLASS",f,"Use class filter",anchor)
	
		anchor.yOfs = 70
	local Classes = {
	"Deathknight",
	"Druid",
	"Hunter",
	"Paladin",
	"Mage",
	"Priest",
	"Rogue",
	"Shaman",
	"Warlock",
	"Warrior",
	}
	local Box,i = {},0
	for k,_ in pairs(Classes) do
		i = i + 1
		Box[k] = CreateNewCheckbox("SGI_FILTERCLASS"..i,f,Classes[k],anchor)
		anchor.yOfs = anchor.yOfs - 20
		if not SuperGuildInviteOptions["Checkbox"]["SGI_USECLASS"] then
			Box[k]:Hide()
		end
	end
	B1:HookScript("OnClick",function()
		if SuperGuildInviteOptions["Checkbox"]["SGI_USECLASS"] then
			for k,_ in pairs(Classes) do
				Box[k]:Show()
			end
		else
			for k,_ in pairs(Classes) do
				Box[k]:Hide()
			end
		end
	end)
	
	
	local LimitLow = CreateFrame("Frame","SGI_LimitLowFrame",f)
	local LimitHigh = CreateFrame("Frame","SGI_LimitHighFrame",f)
	LimitLow:SetWidth(40)
	LimitLow:SetHeight(30)
	LimitLow:SetPoint("TOPLEFT",f,"TOPLEFT",55,-230)
	local LowF = LimitLow:CreateFontString("SGI_LimitFontL","OVERLAY","GameFontNormalLarge")
	LowF:SetPoint("CENTER")
	
	local Test1 = LimitLow:CreateTexture()
	Test1:SetPoint("CENTER")
	Test1:SetTexture(1,1,0,0.2)
	Test1:SetWidth(40)
	Test1:SetHeight(30)
	Test1:Hide()
	local Test2 = LimitHigh:CreateTexture()
	Test2:SetPoint("CENTER")
	Test2:SetTexture(1,1,0,0.2)
	Test2:SetWidth(40)
	Test2:SetHeight(30)
	Test2:Hide()
	
	local LimitTool = CreateFrame("Frame","LimitTool",LimitLow,"GameTooltipTemplate")
	LimitTool:SetWidth(120)
	LimitTool:SetHeight(40)
	LimitTool:SetPoint("TOP",LimitLow,"BOTTOM")
	local LimitToolF = LimitTool:CreateFontString(nil,"OVERLAY","GameFontNormal")
	LimitToolF:SetPoint("LEFT",LimitTool,"LEFT",10,0)
	LimitToolF:SetJustifyH("LEFT")
	LimitToolF:SetText("Scroll to change")
	LimitToolF:SetWidth(110)
	
	
	LimitLow:SetScript("OnEnter",function()
		Test1:Show()
		LimitTool:SetPoint("TOP",LimitLow,"BOTTOM")
		LimitTool:Show()
	end)
	LimitLow:SetScript("OnLeave",function()
		Test1:Hide()
		LimitTool:Hide()
	end)
	LimitHigh:SetScript("OnEnter",function()
		Test2:Show()
		LimitTool:SetPoint("TOP",LimitHigh,"BOTTOM")
		LimitTool:Show()
	end)
	LimitHigh:SetScript("OnLeave",function()
		Test2:Hide()
		LimitTool:Hide()
	end)
	
	SuperGuildInviteOptions.LowFilterLimit = 1
	SuperGuildInviteOptions.HighFilterLimit = 85
	
	LowF:SetText(SuperGuildInviteOptions.LowFilterLimit.." - ")
	LimitLow:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and (SuperGuildInviteOptions.LowFilterLimit + 1 <= SuperGuildInviteOptions.HighFilterLimit) then
			SuperGuildInviteOptions.LowFilterLimit = SuperGuildInviteOptions.LowFilterLimit + 1
			LowF:SetText(SuperGuildInviteOptions.LowFilterLimit.." - ")
		elseif delta == -1 and SuperGuildInviteOptions.LowFilterLimit - 1 > 0 then
			SuperGuildInviteOptions.LowFilterLimit = SuperGuildInviteOptions.LowFilterLimit - 1
			LowF:SetText(SuperGuildInviteOptions.LowFilterLimit.." - ")
		end
	end)
	LimitHigh:SetWidth(40)
	LimitHigh:SetHeight(30)
	LimitHigh:SetPoint("TOPLEFT",f,"TOPLEFT",95,-230)
	local HighF = LimitHigh:CreateFontString("SGI_LimitFontH","OVERLAY","GameFontNormalLarge")
	HighF:SetPoint("CENTER")
	HighF:SetText(SuperGuildInviteOptions.HighFilterLimit)
	LimitHigh:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and (SuperGuildInviteOptions.HighFilterLimit + 1 <= 85) then
			SuperGuildInviteOptions.HighFilterLimit = SuperGuildInviteOptions.HighFilterLimit + 1
			HighF:SetText(SuperGuildInviteOptions.HighFilterLimit)
		elseif delta == -1 and SuperGuildInviteOptions.HighFilterLimit > SuperGuildInviteOptions.LowFilterLimit then
			SuperGuildInviteOptions.HighFilterLimit = SuperGuildInviteOptions.HighFilterLimit - 1
			HighF:SetText(SuperGuildInviteOptions.HighFilterLimit)
		end
	end)
	local LimitFont = LimitLow:CreateFontString(nil,"OVERLAY","GameFontNormal")
	LimitFont:SetPoint("BOTTOM",LimitLow,"TOP",0,3)
	LimitFont:SetText("Level limits:")
	if SuperGuildInviteOptions["Checkbox"]["SGI_FILTERLEVEL"] then
		LimitLow:Show()
		LimitHigh:Show()
	else
		LimitLow:Hide()
		LimitHigh:Hide()
	end
		
	B2:HookScript("OnClick",function()
		if SuperGuildInviteOptions["Checkbox"]["SGI_FILTERLEVEL"] then
			LimitLow:Show()
			LimitHigh:Show()
		else
			LimitLow:Hide()
			LimitHigh:Hide()
		end
	end)
	
end

local function ToggleFilterCreate()
	if SGI_FilterCreate and SGI_FilterCreate:IsShown() then
		SGI_FilterCreate:Hide()
	elseif SGI_FilterCreate then
		SGI_FilterCreate:Show()
	else
		CreateAdvancedFilterCreationFrame()
	end
end


local function CreateRemoveFilterFrame()
	local f = CreateFrame("Frame","SGI_REMOVE_FILTER_FRAME")
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	f:SetWidth(300)
	f:SetHeight(175)
	f:SetBackdrop(backdrop)
	PlaceFrame(f)
	
	f:SetMovable()
	f:RegisterForDrag("LeftButton","RightButton")
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local TitleFont = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("Remove a filter")
	TitleFont:SetPoint("TOP",f,"TOP",0,-20)
	
	local Filters = {}
	for k,_ in pairs(SuperGuildInviteGeneral.filter) do
		tinsert(Filters,k)
	end
	
	local anchor = {}
		anchor.point = "CENTER"
		anchor.relativeFrame = f
		anchor.relativePoint = "CENTER"
		anchor.xOfs = 0
		anchor.yOfs = -0
	
	CreateDropDown(f,"SGI_FILTERREMOVE",anchor,Filters,"FILTERREMOVE","Pick filter")
	anchor.yOfs = -50
	CreateNewButton("SGI_REMOVE_FITLER",f,120,30,"Remove",anchor,function()
		if not SuperGuildInviteOptions["Dropdown"]["FILTERREMOVE"] then
			SuperGuildInviteOptions["Dropdown"]["FILTERREMOVE"] = 1
		end
		SuperGuildInviteGeneral.filter[Filters[SuperGuildInviteOptions["Dropdown"]["FILTERREMOVE"]]] = nil
		SuperGuildInviteOptions["Checkbox"]["SGI_FILTER"..Filters[SuperGuildInviteOptions["Dropdown"]["FILTERREMOVE"]]] = nil
		print("SGI_FILTER"..Filters[SuperGuildInviteOptions["Dropdown"]["FILTERREMOVE"]])
		f:Hide()
		if SGI_FilterOpt then
			SGI_FilterOpt:Hide()
			SGI_FilterOpt = nil
		end
	end)
	
end

local function ToggleFilterRemove()
	if SGI_REMOVE_FILTER_FRAME and SGI_REMOVE_FILTER_FRAME:IsShown() then
		SGI_REMOVE_FILTER_FRAME:Hide()
	elseif SGI_REMOVE_FILTER_FRAME then
		SGI_REMOVE_FILTER_FRAME:Show()
	else
		CreateRemoveFilterFrame()
	end
end

local function CreateHelpInfoFrame()
	local f = CreateFrame("Frame","SGI_FilterHelp")
	
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	f:SetWidth(700)
	f:SetHeight(750)
	f:SetBackdrop(backdrop)
	f:SetFrameStrata("HIGH")
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local yOfs,Spacing = -10,40
	
	local Title1 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title1:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title1:SetText("SuperScan")
	Title1:SetJustifyH("LEFT")
	local InfoText1 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText1:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText1:SetJustifyH("LEFT")
	InfoText1:SetText("SuperScan is the main function to be using with this AddOn. SuperScan will scan every player on your server and check whether they are in a guild or not. If they are not they will be put in the invite queue, and wait for an invite. Starting SuperScan will cause the options frame to be hidden, and a smaller frame will show you the information you need.")
	InfoText1:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText1:GetHeight()
	
	local Title2 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title2:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title2:SetText("Inviting Players")
	Title2:SetJustifyH("LEFT")
	local InfoText2 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText2:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText2:SetJustifyH("LEFT")
	InfoText2:SetText("In order for a player to be invited to your guild you have to do one of the following two ways. You can press the |cff00ff00'Invite: #'|r button located on either the options frame, or the small SuperScan timer. Pressing this button will invite the first player in the queue to your guild. You can also pick the players you want to invite by pressing |cff00ff00'Chose Invites'|r. This will show a frame with all the currently queued players along with some information about them. By |cff00ff00left clicking|r on a player's name you will invite them, while |cffff0000right clicking|r will remove them from the queue.")
	InfoText2:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText2:GetHeight()
	
	local Title3 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title3:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title3:SetText("Lockout")
	Title3:SetJustifyH("LEFT")
	local InfoText3 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText3:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText3:SetJustifyH("LEFT")
	InfoText3:SetText("In order to not spam other players there's a built in lockout system in SGI. Once a player has been invited or removed from the queue they won't be added again for a configurable period of time. This time is configurable on the options frame and can be set to |cff88aaff1, 2, 4 days, 1, 2 weeks|r.")
	InfoText3:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText3:GetHeight()
	
	local Title4 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title4:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title4:SetText("Blacklisting")
	Title4:SetJustifyH("LEFT")
	local InfoText4 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText4:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText4:SetJustifyH("LEFT")
	InfoText4:SetText("If there are players that you never want to invite to you guild you can blacklist them. There are 3 ways a player can be blacklisted. The first way is to manually blacklist them with the command |cffff0000/sgi blacklist name|r, which will black list the player 'name'. The second way is to enable |cffff0000'Automatic blacklisting'|r, which will blacklist a player automatically after a certain number of declines, the default is 3. To change this, use this command: |cff88aaff/sgi blacktime #|r. Where '#' is the number of times a player can decline before being blacklisted. The last way is when the AddOn shares the list with other users within your guild.")
	InfoText4:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText4:GetHeight()
	
	local Title5 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title5:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title5:SetText("Invite Whisper")
	Title5:SetJustifyH("LEFT")
	local InfoText5 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText5:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText5:SetJustifyH("LEFT")
	InfoText5:SetText("If you wish you can send a whisper to the player you are inviting. In order for it to be sent you need to check the checkbox on the main options frame. There's a pretty dull default message that you can use, but if you want to make it more personal you can customize it (max 256 letters) by pressing the button on the options frame and following the instructions there.")
	InfoText5:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText5:GetHeight()
	
	local Title6 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title6:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title6:SetText("Normal Filtering")
	Title6:SetJustifyH("LEFT")
	local InfoText6 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText6:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText6:SetJustifyH("LEFT")
	InfoText6:SetText("The most basic filtering available is to limit the levels of the players you wish to invite. You can change the limit by scrolling with your mouse over the designated area in the options frame. |cffF86CB8Changing this limit will affect the time it takes to complete a SuperScan|r.")
	InfoText6:SetWidth(680)
	
	yOfs = yOfs - Spacing - InfoText6:GetHeight()
	
	local Title7 = f:CreateFontString(nil,"OVERLAY","MovieSubtitleFont")
	Title7:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs)
	Title7:SetText("Advanced Filtering")
	Title7:SetJustifyH("LEFT")
	local InfoText7 = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
	InfoText7:SetPoint("TOPLEFT",f,"TOPLEFT",10,yOfs-30)
	InfoText7:SetJustifyH("LEFT")
	InfoText7:SetText("Advanced filter gives more specificity to the pickier guild masters. In order to use this feature you have to enable the checkbox on the options frame, and then press 'Advanced Filtering'. In this new window you chose what filters to use (more than one at a time is possible). If there are no filters you have to create a new one by pressing 'New Filter'. Here you can chose what your filter will do. The filter mode specifies if you want to invite players that match the filter, or players that don't match the filter. The level filter is what it sounds like, |cffF86CB8but this level range will not affect the time of the SuperScan|r. The class filter allows you to choose which classes to (not) invite. Do note that in order for a player to match a filter they have to match all parts of the filter.")
	InfoText7:SetWidth(680)
end

local function ToggleHelp()
	if SGI_FilterHelp and SGI_FilterHelp:IsShown() then
		SGI_FilterHelp:Hide()
	elseif SGI_FilterHelp then
		SGI_FilterHelp:Show()
	else
		CreateHelpInfoFrame()
	end
end


local function CreateAdvancedFilteringFrame()
	local f = CreateFrame("Frame","SGI_FilterOpt")
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	f:SetWidth(500)
	f:SetHeight(365)
	f:SetBackdrop(backdrop)
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local TitleFont = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("SuperGuildInvite Filters")
	TitleFont:SetPoint("TOP",f,"TOP",0,-20)
	
	local anchor = {}
		anchor.point = "TOPLEFT"
		anchor.relativeFrame = f
		anchor.relativePoint = "TOPLEFT"
		anchor.xOfs = 50
		anchor.yOfs = -50
		
	local i = 0
	for k,_ in pairs(SuperGuildInviteGeneral.filter) do
		i = i + 1
		local CB = CreateNewCheckbox("SGI_FILTER"..k,f,k,anchor)
		CB:HookScript("OnClick",function()
			DisplayFilter(k)
		end)
		anchor.xOfs = anchor.xOfs + 250
		if anchor.xOfs == 550 then
			anchor.xOfs = 50
			anchor.yOfs = anchor.yOfs - 30
		end
	end
	
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 20
		anchor.yOfs = 20
	
	CreateNewButton("SGI_NEW_FILTER",f,120,30,"New filter",anchor,ToggleFilterCreate)
	anchor.xOfs = anchor.xOfs + 170
	CreateNewButton("SGI_REMOVE_FILTER",f,120,30,"Remove filter",anchor,ToggleFilterRemove)
	anchor.xOfs = anchor.xOfs + 170
	
	
end

local function ToggleFilter()
	if SGI_FilterOpt and SGI_FilterOpt:IsShown() then
		SGI_FilterOpt:Hide()
	elseif SGI_FilterOpt then
		SGI_FilterOpt:Show()
	else
		CreateAdvancedFilteringFrame()
	end
end



local function CreateMainOptionsFrame()
	local f = CreateFrame("Frame","SGI_MainOptionsFrame")
	f:SetWidth(550)
	f:SetHeight(350)
	PlaceFrame(f)
	f:SetMovable()
	f:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	f:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		RememberPosition(self)
	end)
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	f:SetBackdrop(backdrop)
	
	-- Close Button --
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	local Title = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	Title:SetText("SuperGuildInvite "..VERSION_MAJOR..VERSION_MINOR..SGI_OPTIONS)
	Title:SetPoint("TOP",f,"TOP",0,-20)
	local BottomFont = f:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	BottomFont:SetText(SGI_WRITTEN_BY.."Janniie - Stormreaver EU")
	BottomFont:SetPoint("BOTTOM",f,"BOTTOM",0,20)
	
	local anchor = {}
			anchor.point = "TOPLEFT"
			anchor.relativePoint = "TOPLEFT"
			anchor.xOfs = 20
			anchor.yOfs = -30
	
	local WhisperMode = {
		"Whisper after inviting",
		"Whisper and invite",
		"Only whisper",
	}
	
	
	-- Checkboxes --
	local EB = CreateNewCheckbox("SGI_ENABLE_BOX",f,SGI_ENABLE,anchor)
		anchor.yOfs = anchor.yOfs - 30
	local WB = CreateNewCheckbox("SGI_WHISPER",f,SGI_SEND_A_WHISPER,anchor)
		anchor.yOfs = anchor.yOfs - 50
	CreateDropDown(f,"SGI_WHISPERWAIT",anchor,WhisperMode,"SGI_WHISPERWAIT","Whisper Type")
		anchor.yOfs = anchor.yOfs - 30
	CreateNewCheckbox("SGI_AUTOBLACKLIST",f,SGI_AUTO_BLACKLIST,anchor)
		anchor.yOfs = anchor.yOfs - 30
	CreateNewCheckbox("SGI_AUTOCLOSE",f,SGI_AUTO_CLOSE_WHO,anchor)
		anchor.yOfs = anchor.yOfs - 30
	CreateNewCheckbox("SGI_SILENTMODE",f,SGI_SILENT_MODE,anchor)
		anchor.yOfs = anchor.yOfs - 30
	local AF = CreateNewCheckbox("SGI_ADVANCEDFILTERING",f,SGI_ADVANCEDFILTERING,anchor)
	
	
	local function WB_HS()
		if SuperGuildInviteOptions["Checkbox"]["SGI_WHISPER"] then
			if SGI_WHISPERWAIT then
				SGI_WHISPERWAIT:Show()
				WB:SetScript("OnUpdate",nil)
			end
		else
			if SGI_WHISPERWAIT then
				SGI_WHISPERWAIT:Hide()
				WB:SetScript("OnUpdate",nil)
			end
		end
	end
	local function AF_HS()
		if SuperGuildInviteOptions["Checkbox"]["SGI_ADVANCEDFILTERING"] then
			if SGI_ADVANCED_FILTER then
				SGI_ADVANCED_FILTER:Enable()
				AF:SetScript("OnUpdate",nil)
			end
		else
			if SGI_ADVANCED_FILTER then
				SGI_ADVANCED_FILTER:Disable()
				AF:SetScript("OnUpdate",nil)
			end
		end
	end
	local function EB_HS()
		if SuperGuildInviteOptions["Checkbox"]["SGI_ENABLE_BOX"] then
			if SGI_SUPERSCAN then
				SGI_SUPERSCAN:Enable()
				EB:SetScript("OnUpdate",nil)
			end
		else
			if SGI_SUPERSCAN then
				SGI_SUPERSCAN:Disable()
				EB:SetScript("OnUpdate",nil)
			end
		end
	end
	
	AF:HookScript("OnClick",AF_HS)
	AF:SetScript("OnUpdate",AF_HS)
	EB:HookScript("OnClick",EB_HS)
	EB:SetScript("OnUpdate",EB_HS)
	WB:HookScript("OnClick",WB_HS)
	WB:SetScript("OnUpdate",WB_HS)
	
	-- Reinvite dropdown menu
	anchor.xOfs = 350
	anchor.yOfs = -80
	local ITEMS = {
		"1 day",
		"2 days",
		"4 days",
		"1 week",
		"2 weeks",
	}
	CreateDropDown(f,"SGI_REINVITE",anchor,ITEMS,"ReinviteLockout","Lockout time")
	
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 20
		anchor.yOfs = 45
	CreateNewButton("SGI_CUSTOM_WHISPER",f,120,30,"Customize Whisper",anchor,ToggleWhisperFrame)
		anchor.xOfs = anchor.xOfs + 125
	CreateNewButton("SGI_SUPERSCAN",f,120,30,"SuperScan",anchor,function()
		if superScanning then
			SuperScanFrame:SetScript("OnUpdate",nil)
			superScanning = false
			ToggleTimer()
		else
			if limitChanged then
				CreateSuperScanQuery(SuperGuildInviteOptions.LowLimit,SuperGuildInviteOptions.HighLimit)
				limitChanged = false
			end
			superScanning = true
			SuperScanFrame:SetScript("OnUpdate",function()
				SuperScan()
				UpdateTimerFrame()
			end)
			ToggleTimer(true)
			f:Hide()
		end
	end)
		anchor.xOfs = anchor.xOfs + 125
	CreateNewButton("SGI_INVITEBUTTON",f,120,30,"Invite: "..CountTable(SGI_Queue),anchor,InvitePlayerButton)
		anchor.xOfs = anchor.xOfs + 125
	CreateNewButton("SGI_CHOOSEINVITES",f,120,30,"Choose Invites",anchor,function()
		if SGI_INVITELISTFRAME and SGI_INVITELISTFRAME:IsShown() then
			SGI_INVITELISTFRAME:Hide()
		elseif SGI_INVITELISTFRAME then
			SGI_INVITELISTFRAME:Show()
		else
			CreateInviteListFrame()
		end
	end)
	anchor.yOfs = 80
	CreateNewButton("SGI_ADVANCED_FILTER",f,120,30,"Advanced Filtering",anchor,ToggleFilter)
	anchor.xOfs = anchor.xOfs - 125
	CreateNewButton("SGI_HELP",f,120,30,"Help",anchor,ToggleHelp)
	
	local LimitLow = CreateFrame("Frame","SGI_LimitLowFrame",f)
	local LimitHigh = CreateFrame("Frame","SGI_LimitHighFrame",f)
	LimitLow:SetWidth(40)
	LimitLow:SetHeight(30)
	LimitLow:SetPoint("CENTER",f,"CENTER",110,0)
	local LowF = LimitLow:CreateFontString("SGI_LimitFontL","OVERLAY","GameFontNormalLarge")
	LowF:SetPoint("CENTER")
	
	local Test1 = LimitLow:CreateTexture()
	Test1:SetPoint("CENTER")
	Test1:SetTexture(1,1,0,0.2)
	Test1:SetWidth(40)
	Test1:SetHeight(30)
	Test1:Hide()
	local Test2 = LimitHigh:CreateTexture()
	Test2:SetPoint("CENTER")
	Test2:SetTexture(1,1,0,0.2)
	Test2:SetWidth(40)
	Test2:SetHeight(30)
	Test2:Hide()
	
	local LimitTool = CreateFrame("Frame","LimitTool",LimitLow,"GameTooltipTemplate")
	LimitTool:SetWidth(120)
	LimitTool:SetHeight(40)
	LimitTool:SetPoint("TOP",LimitLow,"BOTTOM")
	local LimitToolF = LimitTool:CreateFontString(nil,"OVERLAY","GameFontNormal")
	LimitToolF:SetPoint("LEFT",LimitTool,"LEFT",10,0)
	LimitToolF:SetJustifyH("LEFT")
	LimitToolF:SetText("Scroll to change")
	LimitToolF:SetWidth(110)
	
	
	LimitLow:SetScript("OnEnter",function()
		Test1:Show()
		LimitTool:SetPoint("TOP",LimitLow,"BOTTOM")
		LimitTool:Show()
	end)
	LimitLow:SetScript("OnLeave",function()
		Test1:Hide()
		LimitTool:Hide()
	end)
	LimitHigh:SetScript("OnEnter",function()
		Test2:Show()
		LimitTool:SetPoint("TOP",LimitHigh,"BOTTOM")
		LimitTool:Show()
	end)
	LimitHigh:SetScript("OnLeave",function()
		Test2:Hide()
		LimitTool:Hide()
	end)
	
	LowF:SetText(SuperGuildInviteOptions.LowLimit.." - ")
	LimitLow:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and (SuperGuildInviteOptions.LowLimit + 1 <= SuperGuildInviteOptions.HighLimit) then
			SuperGuildInviteOptions.LowLimit = SuperGuildInviteOptions.LowLimit + 1
			LowF:SetText(SuperGuildInviteOptions.LowLimit.." - ")
			limitChanged = true
		elseif delta == -1 and SuperGuildInviteOptions.LowLimit - 1 > 0 then
			SuperGuildInviteOptions.LowLimit = SuperGuildInviteOptions.LowLimit - 1
			LowF:SetText(SuperGuildInviteOptions.LowLimit.." - ")
			limitChanged = true
		end
	end)
	LimitHigh:SetWidth(40)
	LimitHigh:SetHeight(30)
	LimitHigh:SetPoint("CENTER",f,"CENTER",150,0)
	local HighF = LimitHigh:CreateFontString("SGI_LimitFontH","OVERLAY","GameFontNormalLarge")
	HighF:SetPoint("CENTER")
	HighF:SetText(SuperGuildInviteOptions.HighLimit)
	LimitHigh:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and (SuperGuildInviteOptions.HighLimit + 1 <= 85) then
			SuperGuildInviteOptions.HighLimit = SuperGuildInviteOptions.HighLimit + 1
			HighF:SetText(SuperGuildInviteOptions.HighLimit)
			limitChanged = true
		elseif delta == -1 and SuperGuildInviteOptions.HighLimit > SuperGuildInviteOptions.LowLimit then
			SuperGuildInviteOptions.HighLimit = SuperGuildInviteOptions.HighLimit - 1
			HighF:SetText(SuperGuildInviteOptions.HighLimit)
			limitChanged = true
		end
	end)
	local LimitFont = LimitLow:CreateFontString(nil,"OVERLAY","GameFontNormal")
	LimitFont:SetPoint("BOTTOM",LimitLow,"TOP",0,3)
	LimitFont:SetText("Level limits:")
	
	
	
	SGI_UI.Frames.Window["SGI_OPTIONS"] = f
end

do
	local f = CreateFrame("Button","SGI_MiniMapButton",Minimap)
	f:SetWidth(32)
	f:SetHeight(32)
	f:SetFrameStrata("MEDIUM")
	f:SetMovable(true)
	f:SetUserPlaced(true)
	
	f:SetNormalTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButton")
	f:SetPushedTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButtonPushed")
	f:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	
	local tooltip = CreateFrame("Frame","SGI_TooltTipMini",f,"GameTooltipTemplate")
	tooltip:SetPoint("BOTTOMRIGHT",f,"TOPLEFT",0,-3)
	local toolstring = tooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	toolstring:SetPoint("CENTER")
	toolstring:SetText(LOGO.."|cff88aaffSuperGuildInvite|r")
	tooltip:SetWidth(toolstring:GetWidth()+ 20)
	tooltip:SetHeight(30)
	tooltip:Hide()
	f:SetScript("OnEnter",function()
		tooltip:Show()
	end)
	f:SetScript("OnLeave",function()
		tooltip:Hide()
	end)
	
	local function moveButton(self)
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		centerX, centerY = math.abs(x), math.abs(y)
		centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 78, (centerY / sqrt(centerX^2 + centerY^2)) * 78
		centerX = x < 0 and -centerX or centerX
		centerY = y < 0 and -centerY or centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", centerX, centerY)
		RememberPosition(self)
	end
	
	f:SetScript("OnMouseDown",function(self,button)
		if button == "RightButton" then
			self:SetScript("OnUpdate",moveButton)
		end
	end)
	f:SetScript("OnMouseUp",function(self,button)
		self:SetScript("OnUpdate",nil)
	end)
	f:SetScript("OnClick",function(self,button)
		if button == "LeftButton" then
			if not SGI_UI.Frames.Window["SGI_OPTIONS"] then  --## Need changes
				CreateMainOptionsFrame()
				SGI_UI.Frames.Window["SGI_OPTIONS"]:Show()
			elseif SGI_UI.Frames.Window["SGI_OPTIONS"]:IsShown() then
				SGI_UI.Frames.Window["SGI_OPTIONS"]:Hide()
			else
				SGI_UI.Frames.Window["SGI_OPTIONS"]:Show()
			end
		end
	end)
end



function SlashCmdList.SUPERGUILDINVITE(msg)
	if msg == 'reset' then
		SuperGuildInviteGeneral = nil
		SuperGuildInviteOptions = nil
		BlackList = nil
		print(LOGO.."|cff88aaffis reseting all previous encounters, options and blacklistings...|r")
		LoginPlayer()
		print(LOGO.."|cff88aaff...Reset Complete.|r")
	elseif msg == 'on' then
		SuperGuildInviteOptions["Checkbox"]["SGI_ENABLE_BOX"] = true
		if SGI_ENABLE_BOX then
			SGI_ENABLE_BOX:SetChecked()
		end
		ChatFrame1:AddMessage(LOGO..SGI_TURNED_ON,0,1,0,1)
	elseif msg == 'off' then
		SuperGuildInviteOptions["Checkbox"]["SGI_ENABLE_BOX"] = false
		if SGI_ENABLE_BOX then
			SGI_ENABLE_BOX:SetChecked(false)
		end
		ChatFrame1:AddMessage(LOGO..SGI_TURNED_OFF,1,0,0,1)
	elseif msg == 'config' then
		if not SGI_UI.Frames.Window["SGI_OPTIONS"] then  --## Need changes
			CreateMainOptionsFrame()
			SGI_UI.Frames.Window["SGI_OPTIONS"]:Show()
		elseif SGI_UI.Frames.Window["SGI_OPTIONS"]:IsShown() then
			SGI_UI.Frames.Window["SGI_OPTIONS"]:Hide()
		else
			SGI_UI.Frames.Window["SGI_OPTIONS"]:Show()
		end
	elseif msg == 'test' then
		print("|cff10E825Low: |r|cffffff00"..SuperGuildInviteOptions.LowLimit.."|r")
		print("|cff10E825High: |r|cffffff00"..SuperGuildInviteOptions.HighLimit.."|r")
		CreateSuperScanQuery(SuperGuildInviteOptions.LowLimit,SuperGuildInviteOptions.HighLimit)
		print("|cff10E825Current who query strings:|r")
		local i = 0
		for k,_ in pairs(whoQueryList) do
			print("|cff10E825"..k..". |r|cffffff00"..whoQueryList[k].."|r")
			i = k
		end
		print("|cff10E825Total: |r|cffffff00"..i.."|r")
		print("|cff10E825Estimated Time: |r|cffffff00"..FormatTime((#whoQueryList - scanZone + 1) * whoDelay).."|r")
	elseif msg == 'purge' then
		SGI_Queue = {}
		if SGI_INVITEBUTTONFont then
			SGI_INVITEBUTTONFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
		if SGI_InviteButtonFont then
			SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_Queue))
		end
		ListNamesToInvite()
		print(LOGO.."|cff88aaffThe invite queue has been purged.|r")
	elseif msg == 'showblacklist' then
		DisplayBlacklist()
	elseif strfind(msg,"unblacklist") then
		local name = strsub(msg,13)
		RemoveFromBlacklist(name)
	elseif strfind(msg,"blacklist") then
		local name = strsub(msg,11)
		AddToBlacklist(name,"MANUAL")
	elseif strfind(msg,"blacktime") then
		local tries = tonumber(strsub(msg,11))
		SuperGuildInviteOptions.tries = tries
		print(LOGO..SGI_BLACKTIME_CHANGED.."|cffffff00"..SuperGuildInviteOptions.tries.."|r|cff88aaff"..SGI_CURRENT_BLACKTIME2)
	else
		print(LOGO.."|cff88aaffVersion |r|cff88ffff"..VERSION_MAJOR..VERSION_MINOR)
		print(LOGO.."|cff88aaffSlashCommands:")
		print(LOGO.."|cff88aaff/sgi on|r|cff88ffff"..SGI_SLASH_COMMANDS[2].."|r")
		print(LOGO.."|cff88aaff/sgi off|r|cff88ffff"..SGI_SLASH_COMMANDS[3].."|r")
		print(LOGO.."|cff88aaff/sgi config|r|cff88ffff"..SGI_SLASH_COMMANDS[4].."|r")
		print(LOGO.."|cff88aaff/sgi showblacklist|r|cff88ffff"..SGI_SLASH_COMMANDS[6].."|r")
		print(LOGO.."|cff88aaff/sgi purge|r|cff88ffff"..SGI_SLASH_COMMANDS[7].."|r")
		print(LOGO.."|cff88aaff/sgi unblacklist name|r|cff88ffff"..SGI_SLASH_COMMANDS[11].."|r")
		print(LOGO.."|cff88aaff/sgi blacklist name|r|cff88ffff"..SGI_SLASH_COMMANDS[8].."|r")
		print(LOGO.."|cff88aaff/sgi blacktime #|r|cff88ffff"..SGI_SLASH_COMMANDS[9].."|r")
		print(LOGO.."|cff88aaff/sgi reset|r|cff88ffff"..SGI_SLASH_COMMANDS[10].."|r")
	end
end	